/**********************************************************************

UML StateWizard provides its software under two flexible licenses: 

1) the GPL License and zlib/libpng License for open source projects. 
2) the UML StateWizard Commercial License for commercial projects.

Email us at info@intelliwizard.com for any information, suggestions and 

feature requestions.

www.intelliwizard.com

*************************************************************************/

// SamplePlayerMfcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SamplePlayerMfc.h"
#include "SamplePlayerMfcDlg.h"
#include "sme.h"
#include "SrvAgent.h"
#include "EventId.h"
#include "sme_debug.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HWND g_hwndMain=NULL;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSamplePlayerMfcDlg dialog

CSamplePlayerMfcDlg::CSamplePlayerMfcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSamplePlayerMfcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSamplePlayerMfcDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSamplePlayerMfcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSamplePlayerMfcDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSamplePlayerMfcDlg, CDialog)
	//{{AFX_MSG_MAP(CSamplePlayerMfcDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_POWER, OnButtonPower)
	ON_BN_CLICKED(IDC_BUTTON_PAUSE, OnButtonPause)
	ON_WM_DESTROY()
	ON_MESSAGE(WM_STATE_UPDATE, OnStateUpdate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSamplePlayerMfcDlg message handlers

// The application thread context.
SME_THREAD_CONTEXT_T g_AppThreadContext;


SME_DEC_EXT_APP_VAR(Player);

BOOL CSamplePlayerMfcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	g_hwndMain = m_hWnd;

	// Initialize engine.
	g_AppThreadContext.nAppThreadID = 0;
	SmeInitEngine(&g_AppThreadContext); 
	// Hook dialog. MfcPostExtPtrEventToWnd() will post an external event to this dialog.
	MfcHookWnd(GetSafeHwnd()); 
	SmeActivateApp(&SME_GET_APP_VAR(Player),NULL);

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSamplePlayerMfcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSamplePlayerMfcDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSamplePlayerMfcDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

typedef struct MSG_KEY_PRESS_T
{
	unsigned short nKeyCode;
}MSG_KEY_PRESS_T;

void CSamplePlayerMfcDlg::OnButtonPower() 
{
	// TODO: Add your control notification handler code here
	// 1)
	//MSG_KEY_PRESS_T KeyPressMsg;
	//KeyPressMsg.nKeyCode = 0;
	//MfcPostExtPtrEventToWnd(EXT_EVENT_ID_POWER, &KeyPressMsg, sizeof(MSG_KEY_PRESS_T), NULL, GetSafeHwnd());
	// 2)
	//MfcPostExtIntEventToWnd(EXT_EVENT_ID_POWER, 0, 0, NULL, GetSafeHwnd());
	// 3)
	MfcSendExtIntEventToWnd(EXT_EVENT_ID_POWER, 0, 0, NULL, GetSafeHwnd());
	
}

void CSamplePlayerMfcDlg::OnButtonPause() 
{
	// TODO: Add your control notification handler code here
	MfcSendExtIntEventToWnd(EXT_EVENT_ID_PAUSE_RESUME, 0, 0, NULL, GetSafeHwnd());
	
}

void CSamplePlayerMfcDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
}

extern TCHAR * sStateMapping[]; 

LRESULT CSamplePlayerMfcDlg::OnStateUpdate(WPARAM wParam, LPARAM lParam)
{
	SetDlgItemText(IDC_STATIC_STATE, sStateMapping[wParam]);
	return 0;
}
